<?
/*
	SMF Archive Version: 1.2
	1.1 just normal archive not tied into SMF SEO yet wait for 1.2

	Install: Just upload archive.php to your forum's main directory

	License: The footer links must remain. If you want to remove them you need to talk to me.
	************************
	archive.php - Generates a search engine friendly version of the forum.
	************************
	Function list
	void archive_board($boardid) - shows a board's topics passed is the ID_BOARD
	void archive_topic($topicid) - shows a topic's post passed is the ID_TOPIC
	void archive_main() - shows the board index of the archive
	//Template functions
	void archive_header($title, $url) - shows the header html information for the template. Takes a title of the page and the url to the full version
	void archive_footer() - shows the footer html for the archive. Links must remain!

*/
define('SMF', '1');

//Report all the errors
error_reporting(E_ALL);

//Get the database and board information
require_once(dirname(__FILE__) . '/Settings.php');


//Max topics to show per page in a forum
$maxtopics = 20;
//Max posts to show per page in a topic
$maxposts = 15;

//Check if board is in maintenance mode
if($maintenance == 2)
	die('Forumumuz uan Kapaldr.Bakm almas Tamamlandktan Sonra Alacaktr.');


//Connect to the database
if($db_persist == 0)
	$db_connection = @mysql_connect($db_server, $db_user, $db_passwd);
else
	$db_connection = @mysql_pconnect($db_server, $db_user, $db_passwd);

//Check if you can connect to the database
if (!$db_connection )
	die('Bir Sorun Olutu Ltfen Daha Sonra Deneyiniz.');

if(!@mysql_select_db($db_name, $db_connection ))
	die('Bir Sorun Olutu Ltfen Daha Sonra Deneyiniz.');

//Take off that wirless warning
define('WIRELESS', false);
//These are mainly here to check for user permissions what boards and topics they can view.
require_once($sourcedir . '/QueryString.php');
require_once($sourcedir . '/Subs.php');
require_once($sourcedir . '/Errors.php');
require_once($sourcedir . '/Load.php');
require_once($sourcedir . '/Security.php');
if (@version_compare(PHP_VERSION, '4.2.3') != 1)
	require_once($sourcedir . '/Subs-Compat.php');

reloadSettings();
cleanRequest();

//Load User Setttings
loadUserSettings();
$user_info['smiley_set']  = $modSettings['smiley_sets_default'];
	$user_info['groups'] = array_unique($user_info['groups']);

	// Just build this here, it makes it easier to change/use.
	if ($user_info['is_guest'])
		$user_info['query_see_board'] = 'FIND_IN_SET(-1, b.memberGroups)';
	// Administrators can see all boards.
	elseif ($user_info['is_admin'])
		$user_info['query_see_board'] = '1';
	// Registered user.... just the groups in $user_info['groups'].
	else
		$user_info['query_see_board'] = '(FIND_IN_SET(' . implode(', b.memberGroups) OR FIND_IN_SET(', $user_info['groups']) . ', b.memberGroups))';

if(!isset($topic))
loadBoard();

//Load the Current User Permmissions
loadPermissions();

//Check if they have smfseo installed and turned on
if(@$modSettings['smfseo_enabled'] == 1)
	$smfseo = true;
else
	$smfseo = false;


$board = '';
$topic = '';


//All $context['browser'] code from loadTheme from Load.php
// The following determines the user agent (browser) as best it can.
$context['browser'] = array(
		'is_opera' => strpos($_SERVER['HTTP_USER_AGENT'], 'Opera') !== false,
		'is_opera6' => strpos($_SERVER['HTTP_USER_AGENT'], 'Opera 6') !== false,
		'is_opera7' => strpos($_SERVER['HTTP_USER_AGENT'], 'Opera 7') !== false || strpos($_SERVER['HTTP_USER_AGENT'], 'Opera/7') !== false,
		'is_opera8' => strpos($_SERVER['HTTP_USER_AGENT'], 'Opera 8') !== false || strpos($_SERVER['HTTP_USER_AGENT'], 'Opera/8') !== false,
		'is_ie4' => strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 4') !== false && strpos($_SERVER['HTTP_USER_AGENT'], 'WebTV') === false,
		'is_safari' => strpos($_SERVER['HTTP_USER_AGENT'], 'Safari') !== false,
		'is_mac_ie' => strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 5.') !== false && strpos($_SERVER['HTTP_USER_AGENT'], 'Mac') !== false,
		'is_web_tv' => strpos($_SERVER['HTTP_USER_AGENT'], 'WebTV') !== false,
		'is_konqueror' => strpos($_SERVER['HTTP_USER_AGENT'], 'Konqueror') !== false,
		'is_firefox' => strpos($_SERVER['HTTP_USER_AGENT'], 'Firefox') !== false,
	);
$context['browser']['is_gecko'] = strpos($_SERVER['HTTP_USER_AGENT'], 'Gecko') !== false && !$context['browser']['is_safari'] && !$context['browser']['is_konqueror'];

// Internet Explorer 5 and 6 are often "emulated".
$context['browser']['is_ie7'] = strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 7') !== false && !$context['browser']['is_opera'] && !$context['browser']['is_gecko'] && !$context['browser']['is_web_tv'];
$context['browser']['is_ie6'] = strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 6') !== false && !$context['browser']['is_opera'] && !$context['browser']['is_gecko'] && !$context['browser']['is_web_tv'];
$context['browser']['is_ie5.5'] = strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 5.5') !== false && !$context['browser']['is_opera'] && !$context['browser']['is_gecko'] && !$context['browser']['is_web_tv'];
$context['browser']['is_ie5'] = strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 5.0') !== false && !$context['browser']['is_opera'] && !$context['browser']['is_gecko'] && !$context['browser']['is_web_tv'];

$context['browser']['is_ie'] = $context['browser']['is_ie4'] || $context['browser']['is_ie5'] || $context['browser']['is_ie5.5'] || $context['browser']['is_ie6'] || $context['browser']['is_ie7'];
$context['browser']['needs_size_fix'] = ($context['browser']['is_ie5'] || $context['browser']['is_ie5.5'] || $context['browser']['is_ie4'] || $context['browser']['is_opera6']) && strpos($_SERVER['HTTP_USER_AGENT'], 'Mac') === false;




//Get the board ID
@$board = $_GET['board'];

//Get the topic ID
@$topic = $_GET['topic'];






if($board == '' && $topic == '')
{
	archive_main();
	exit();
}
if($board != '')
{
	archive_board($board);
	exit();
}
if($topic != '')
{
	archive_topic($topic);
	exit();
}
function archive_board($boardid)
{
	global $boardurl, $db_prefix, $maxtopics, $mbname;

	$boardid = addslashes($boardid);
	$start = $_REQUEST['start'];



	$request = db_query("SELECT b.name, b.numTopics
	FROM {$db_prefix}boards AS b
	WHERE b.ID_BOARD = $boardid", __FILE__, __LINE__);
	$row = mysql_fetch_assoc($request);



	archive_header($row['name'],$boardurl . '/index.php?board=' . $boardid . '.' . $start);
	//Show board Menu Parent List
	echo '<div id="linktree"><a href="' . $boardurl . '/arsiv.html">Ariv Anasayfa</a></div>';


	//Show Pages List
	$totalpages = (int) $row['numTopics'] / $maxtopics;
	if($totalpages < 1)
		$totalpages = 1;

	echo '<div id="pages">Pages: ';
	for($i=1; $i <= $totalpages; $i++)
	{
		if($i != $totalpages)
			echo '<a href="' . $boardurl . '/arsiv.html?board=' . $boardid . '.' . (($i-1) * $maxtopics) . '">' . $i . '</a>,&nbsp;';
		else
			echo '<a href="' . $boardurl . '/arsiv.html?board=' . $boardid . '.' . (($i-1) * $maxtopics) . '">' . $i . '</a>';
	}
	echo '</div>';

	echo '<div id="forum">';
	$request2 = db_query("SELECT m.subject, t.ID_TOPIC, t.numReplies
	FROM {$db_prefix}messages AS m, {$db_prefix}topics AS t
	WHERE m.ID_BOARD = $boardid AND m.ID_MSG = t.ID_FIRST_MSG
	ORDER BY t.ID_LAST_MSG DESC
	LIMIT $start,$maxtopics", __FILE__, __LINE__);
	$i = 0;
	while($row2 = mysql_fetch_assoc($request2))
	{
		$i++;
		echo  $i . '.&nbsp;<a href="' . $boardurl . '/arsiv-baslik' . $row2['ID_TOPIC'] . '.0.html">' . $row2['subject'] . '</a> (' . $row2['numReplies'] . ' Cevap)<br />';

	}
	echo '</div>';
	archive_footer();

}
function archive_topic($topicid)
{
	global $boardurl, $db_prefix, $maxposts, $user_info, $mbname;


	$topicid = addslashes($topicid);

	$start = $_REQUEST['start'];

	$request = db_query("SELECT m.subject, t.numReplies, b.name, b.ID_BOARD, m.ID_BOARD
	FROM {$db_prefix}messages AS m, {$db_prefix}topics AS t,
	{$db_prefix}boards AS b
	WHERE b.ID_BOARD = m.ID_BOARD AND t.ID_TOPIC = $topicid AND m.ID_MSG = t.ID_FIRST_MSG AND $user_info[query_see_board]", __FILE__, __LINE__);
	$row = mysql_fetch_assoc($request);

	archive_header($row['subject'],$boardurl . '/index.php?topic=' . $topicid . '.' . $start);



	echo '<div id="linktree"><a href="' . $boardurl . '/arsiv.html">Ariv Anasayfa</a>&nbsp;<a href="' . $boardurl . '/arsiv-konu' . $row['ID_BOARD'] . '.0.html">' . $row['name'] . '</a></div>';


	//Show Pages List
	$totalpages = floor($row['numReplies'] / $maxposts) + 1;
	if($totalpages < 1)
		$totalpages = 1;


	echo '<div id="pages">Sayfalar: ';
	for($i=1; $i <= $totalpages; $i++)
	{
		if($i != $totalpages)
			echo '<a href="' . $boardurl . '/arsiv.html?topic=' . $topicid . '.' . (($i-1) * $maxposts) . '">' . $i . '</a>,&nbsp;';
		else
			echo '<a href="' . $boardurl . '/arsiv.html?topic=' . $topicid . '.' . (($i-1) * $maxposts) . '">' . $i . '</a>';
	}
	echo '</div>';

	//Get all posts in a topic
	$request2 = db_query("SELECT m.subject, m.posterName, m.body, m.posterTime
		FROM {$db_prefix}messages AS m
		LEFT JOIN {$db_prefix}boards AS b ON(b.ID_BOARD = m.ID_BOARD)
		WHERE m.ID_TOPIC = $topicid AND $user_info[query_see_board] ORDER BY m.ID_MSG ASC LIMIT $start,$maxposts", __FILE__, __LINE__);

	echo '<div id="topic">';
	while($row2 = mysql_fetch_assoc($request2))
	{
		echo $row2['subject'] . ' By: ' . $row2['posterName'] . ' Date: ' . timeformat($row2['posterTime']) . '<br />';
		if(function_exists('parse_bbc'))
			echo parse_bbc($row2['body']);
		else
			echo doUBBC($row2['body']);

		echo '<hr />';
	}

	echo '</div>';

	archive_footer();

}
function archive_main()
{
	global $mbname,$boardurl, $db_prefix, $ID_MEMBER, $user_info, $modSettings;

	archive_header($mbname,$boardurl);


	//Show cats
	echo '<div id="main"><ul>';

	$request1 = db_query("SELECT c.ID_CAT, c.catOrder, c.name
	FROM {$db_prefix}categories AS c
	ORDER BY c.catOrder ASC", __FILE__, __LINE__);
	while ($row1 = mysql_fetch_assoc($request1))
	{


		$catid = $row1['ID_CAT'];



		$request2 = db_query("
			SELECT
				b.name, b.numPosts, b.ID_BOARD, b.ID_CAT, b.childLevel, b.ID_PARENT, b.boardOrder
			FROM {$db_prefix}boards AS b
				LEFT JOIN {$db_prefix}log_boards AS lb ON (lb.ID_BOARD = b.ID_BOARD AND lb.ID_MEMBER = $ID_MEMBER)
			WHERE $user_info[query_see_board]" . (!empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0 ? "
				AND b.ID_BOARD != " . (int) $modSettings['recycle_board'] : '') . " AND $catid = b.ID_CAT
			", __FILE__, __LINE__);

		$b_count = db_affected_rows();
		if($b_count !=0)
		{
			echo '<li><b>' . $row1['name'] . '</b></li>';
			//List the forums and subforums

			echo '<ul>';
			while ($row2 = mysql_fetch_assoc($request2))
			{
				echo '<li><a href="' . $boardurl . '/arsiv-konu' . $row2['ID_BOARD'] . '.0.html">' . $row2['name'] . '</a> (' . $row2['numPosts'] . ' mesaj)</li>';
			}
			echo '</ul>';
		}
		mysql_free_result($request2);

	}
	mysql_free_result($request1);

	echo '</ul></div>';

	archive_footer();
}
function archive_header($title, $url)
{
	global $boardurl;
 echo '
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
 <html>
 <head>
 	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-9" />
	<meta name="description" content="' . $title . '" />
 	<title>' . $title . '</title>
 	<link rel="stylesheet" type="text/css" href="arsiv.css" />
 </head>
 <body>
 	<div id="header">
		<div id="fullver">Full Versiyonu Gster: <a href="' . $url . '">' . $title . '</a>
		</div>
		<div id="menu" align="center"><a href="' . $boardurl . '/index.php?action=help">Yardm</a>&nbsp;<a href="' . $boardurl . '/index.php?action=search">Arama</a>&nbsp;<a href="' . $boardurl . '/index.php?action=mlist">ye Listesi</a>
		</div>
	</div>';

}
function archive_footer()
{
//Link back to SMF Hacks must remain.
echo '<br /><div align="center" id="footer">
	<span style="font-family: Trebuchet MS, sans-serif; font-size: 80%; "><a href="http://www.bisohbet.com" target="blank">SMF</a><a href="http://www.bisohbet.com/form/" target="blank">arsiv</a></span></div>
	</body></html>';
}
?>